/*
https://storage.googleapis.com/chromium-browser-continuous/Win_x64/275917/mini_installer.exe
http://cache.pack.google.com/edgedl/chrome/win/AF4268C6C53AA85A/37.0.2031.2_chrome_installer.exe

STABLE version:
http://clients2.google.com/service/update2/crx?x=id%3D{8A69D345-D564-463C-AFF1-A69D9E530F96}%26uc

BETA version:
http://clients2.google.com/service/update2/crx?x=id%3D{8A69D345-D564-463C-AFF1-A69D9E530F96}%26uc&ap=1.1-beta

DEV version:
http://clients2.google.com/service/update2/crx?x=id%3D{8A69D345-D564-463C-AFF1-A69D9E530F96}%26uc&ap=2.0-dev

CANARY version:
http://clients2.google.com/service/update2/crx?x=id%3D{4ea16ac7-fd5a-47c3-875b-dbf4a2008c20}%26uc

*/
!define APPSIZE	"93500" # kB
!define DLVER	"Multiversion_Online"
!define APPVER 	"0.0.0.0"
!define APPNAME "Chrome"
!define APP 	"Chrome"
!define DLNAME	"Chrome"
!define APPLANG	"Multilingual"
!define FOLDER	"ChromePortable"
!define FINISHRUN
!define OPTIONS ; Delete if no Components
; !define DESCRIPTION	"Google Internet browser"
!define SOURCES

SetCompressor /SOLID lzma
SetCompressorDictSize 32

!include "..\_Include\Installer.nsh"
!include "LogicLib.nsh"
!include "XML.nsh"

!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Arabic"
!insertmacro MUI_LANGUAGE "Bulgarian"
!insertmacro MUI_LANGUAGE "Catalan"
!insertmacro MUI_LANGUAGE "Czech"
!insertmacro MUI_LANGUAGE "Danish"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Greek"
!insertmacro MUI_LANGUAGE "SpanishInternational"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Estonian"
!insertmacro MUI_LANGUAGE "Farsi"
!insertmacro MUI_LANGUAGE "Finnish"
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "Hebrew"
!insertmacro MUI_LANGUAGE "Croatian"
!insertmacro MUI_LANGUAGE "Hungarian"
!insertmacro MUI_LANGUAGE "Indonesian"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Japanese"
!insertmacro MUI_LANGUAGE "Korean"
!insertmacro MUI_LANGUAGE "Lithuanian"
!insertmacro MUI_LANGUAGE "Latvian"
!insertmacro MUI_LANGUAGE "Malay"
!insertmacro MUI_LANGUAGE "Dutch"
!insertmacro MUI_LANGUAGE "Polish"
!insertmacro MUI_LANGUAGE "PortugueseBR"
!insertmacro MUI_LANGUAGE "Portuguese"
!insertmacro MUI_LANGUAGE "Romanian"
!insertmacro MUI_LANGUAGE "Russian"
!insertmacro MUI_LANGUAGE "Slovak"
!insertmacro MUI_LANGUAGE "Slovenian"
!insertmacro MUI_LANGUAGE "Serbian"
!insertmacro MUI_LANGUAGE "Swedish"
!insertmacro MUI_LANGUAGE "Thai"
!insertmacro MUI_LANGUAGE "Turkish"
!insertmacro MUI_LANGUAGE "Ukrainian"
!insertmacro MUI_LANGUAGE "SimpChinese"
!insertmacro MUI_LANGUAGE "TradChinese"

Var RELEASURL
Var DOWNLINK
Var NEWVER
Var SIZE

Function Install

	RMDir "/r" "$TEMP\${APP}PortableTemp"
	CreateDirectory "$TEMP\${APP}PortableTemp"
Call CheckConnected
	inetc::get "$RELEASURL" "$TEMP\${APP}PortableTemp\SnifLink.xml" /END
	Pop $0
StrCmp $0 "OK" +3
	MessageBox MB_USERICON "Download of SnifLink.xml: $0"
	Abort

	${xml::LoadFile} "$TEMP\${APP}PortableTemp\SnifLink.xml" $0
	${xml::GotoPath} "/gupdate/app/updatecheck" $0
	${xml::GetAttribute} "codebase" $DOWNLINK $0 
	${xml::GetAttribute} "Version" $NEWVER $0 
	${xml::GetAttribute} "size" $SIZE $0 
	${xml::Unload}

IntOp $SIZE $SIZE / 1048576

${If} ${FileExists} "$INSTDIR\App\${APP}\chrome.dll"
GetDllVersion "$INSTDIR\App\${APP}\chrome.dll" $R0 $R1
IntOp $R2 $R0 / 0x00010000
IntOp $R3 $R0 & 0x0000FFFF
IntOp $R4 $R1 / 0x00010000
IntOp $R5 $R1 & 0x0000FFFF
StrCpy $0 "$R2.$R3.$R4.$R5"
MessageBox MB_OKCANCEL "Replace $0 with $NEWVER ?$\n$SIZE MB will be downloaded." IDOK install IDCANCEL cancelled
${Else}
MessageBox MB_OKCANCEL "Install $NEWVER ?$\n$SIZE MB will be downloaded." IDOK install IDCANCEL cancelled
${EndIf}

install:

	inetc::get "$DOWNLINK" "$TEMP\${APP}PortableTemp\chrome_installer.exe" /END
	Pop $0
StrCmp $0 "OK" +3
	MessageBox MB_USERICON "Download of chrome_installer.exe: $0"
	Abort

	File "/oname=$TEMP\${APP}PortableTemp\7za.exe" "..\_Include\7-Zip\7za.exe"
	nsExec::Exec `"$TEMP\${APP}PortableTemp\7za.exe" x "$TEMP\${APP}PortableTemp\chrome_installer.exe" -o"$TEMP\${APP}PortableTemp"`
	nsExec::Exec `"$TEMP\${APP}PortableTemp\7za.exe" x "$TEMP\${APP}PortableTemp\chrome.7z" -o"$TEMP\${APP}PortableTemp"`

	SetOutPath "$INSTDIR"
		File "..\..\..\${FOLDER}\${APP}Portable.exe"
	SetOutPath "$INSTDIR\App\DefaultData\${APP}\Default"
		File "Default\Preferences"
		File "Default\Bookmarks"
	SetOutPath "$INSTDIR\App\${APP}"
	FileOpen $0 "$INSTDIR\App\${APP}\First Run" w
	FileClose $0
	CopyFiles /SILENT /FILESONLY "$TEMP\${APP}PortableTemp\Chrome-bin\*.*" "$INSTDIR\App\${APP}"
	CopyFiles /SILENT "$TEMP\${APP}PortableTemp\Chrome-bin\$NEWVER\*.*" "$INSTDIR\App\${APP}"

!ifdef DESCRIPTION
	Call AppInfo
!endif
!ifdef SOURCES
	Call Sources
	SetOutPath "$INSTDIR\Other\_Include\7-Zip"
	File "..\_Include\7-Zip\7za.exe"
	SetOutPath "$INSTDIR\Other\Source\Default"
	File "Default\Preferences"
!endif
!ifdef SOURCES & DESCRIPTION
	Call SourceInfo
!endif

cancelled:
FunctionEnd

Function .onGUIEnd
	RMDir "/r" "$TEMP\${APP}PortableTemp"
FunctionEnd

Section "Chrome Stable" SEC_STABLE 
	SectionIn 1
StrCpy $RELEASURL "http://clients2.google.com/service/update2/crx?x=id%3D{8A69D345-D564-463C-AFF1-A69D9E530F96}%26uc"
	Call Install
SectionEnd
 
Section /o "Chrome Beta" SEC_BETA 
  SectionIn 2
StrCpy $RELEASURL "http://clients2.google.com/service/update2/crx?x=id%3D{8A69D345-D564-463C-AFF1-A69D9E530F96}%26uc&ap=1.1-beta"
	Call Install
SectionEnd
 
Section /o "Chrome Dev" SEC_DEV 
  SectionIn 3
StrCpy $RELEASURL "http://clients2.google.com/service/update2/crx?x=id%3D{8A69D345-D564-463C-AFF1-A69D9E530F96}%26uc&ap=2.0-dev"
	Call Install
SectionEnd
 
Section /o "Chrome Canary" SEC_CANARY 
  SectionIn 4
StrCpy $RELEASURL "http://clients2.google.com/service/update2/crx?x=id%3D{4ea16ac7-fd5a-47c3-875b-dbf4a2008c20}%26uc"
	Call Install
SectionEnd

Function Init
SectionSetSize ${SEC_STABLE} 93500 # kB
SectionSetSize ${SEC_BETA} 93500 # kB
SectionSetSize ${SEC_DEV} 93500 # kB
SectionSetSize ${SEC_CANARY} 93500 # kB
StrCpy $1 ${SEC_STABLE}
FunctionEnd
 
Function .onSelChange
  !insertmacro StartRadioButtons $1
   !insertmacro RadioButton ${SEC_STABLE}
   !insertmacro RadioButton ${SEC_BETA}
   !insertmacro RadioButton ${SEC_DEV}
   !insertmacro RadioButton ${SEC_CANARY}
  !insertmacro EndRadioButtons
FunctionEnd